jQuery(document).ready(function($){

	// Only do it once

	var didSend = false;

	// For verifying email addresses

	var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;

	// Delay the bindings for 5 seconds to stop syncing auto-fills.
	setTimeout( function() {

		// WooCommerce

		$( '.woocommerce input[type=email],.wp-block-woocommerce-checkout input#billing-last_name' ).blur(function() {
			// Validate email
			var email = $('input[type=email],.wp-block-woocommerce-checkout input#email').val().trim();

			if(regex.test(email) == true && didSend == false ) {

				let woo_blocks_used = false;
				if($('.wp-block-woocommerce-checkout').length){
					woo_blocks_used = true;
				}

				if(woo_blocks_used){
					var formData = {};
					$(this).closest('form.wc-block-checkout__form').find('input, select, textarea').each(function() {
						var input = $(this);
						var id = input.attr('id');
						if (id) {
							formData[id] = input.val().trim();
						}
					});
					formData = $.param(formData);
				}else{
					var formData = $('form.checkout').serialize();
				}

				var data = {
					'action' : 'wpf_abandoned_cart_woocommerce',
					'data'   : formData,
					'source' : 'woocommerce',
					'nonce'  : wpf_ac_data.nonce,
				}

				$.post(wpf_ac_data.ajaxurl, data, function( response ) {
					if ( wpf_ac_data.progressive_updates ) {
						if(woo_blocks_used){
							var prog_fields = 'input#shipping-last_name,input#shipping-phone,input#billing-last_name,input#billing-phone';
						}else{
							var prog_fields = 'input#billing_last_name, input#billing_phone';
						}

						$(prog_fields).blur(function( event ) {
							if(woo_blocks_used){
								var formData = {};
								$(this).closest('form.wc-block-checkout__form').find('input, select, textarea').each(function() {
									var input = $(this);
									var id = input.attr('id');
									if (id) {
										formData[id] = input.val().trim();
									}
								});

								formData = $.param(formData);
							}else{
								var formData = $('form.checkout').serialize();
							}
			
							var data = {
								'action'     : 'wpf_progressive_update_cart',
								'data'       : formData,
								'contact_id' : response.data,
								'source'     : 'woocommerce',
								'nonce'      : wpf_ac_data.nonce,
							}

							$.post(wpf_ac_data.ajaxurl, data);

						});

						// WooCommerce cart updates on checkout (WooFunnels, cartflows, etc).

						$( document.body ).on( 'updated_checkout', function( data ) {

							formData = $('form.checkout').serialize();

							var data = {
								'action' : 'wpf_abandoned_cart_woocommerce',
								'data'   : formData,
								'source' : 'woocommerce',
							}

							$.post(wpf_ac_data.ajaxurl, data);

						});

					}

				} );

				didSend = true;

			}

		});

		// LifterLMS

		$( '.llms-checkout input' ).blur(function() {

			// Validate email
			var email = $('input#email_address').val();

			if( didSend == false && regex.test( email ) == true && $('input#first_name').val() && $('input#last_name').val() ) {

				didSend = true;

				var formData = $('form.llms-checkout').serialize();
				var data = {
					'action'     : 'wpf_abandoned_cart',
					'data' 		 : formData,
					'source'     : 'lifterlms',
					'nonce'      : wpf_ac_data.nonce,
				}

				$.post(wpf_ac_data.ajaxurl, data);

			}

		});

		if( wpf_ac_data.wpf_ac_on_submit && parseInt( wpf_ac_data.on_submit ) === 1 ){
			$( '.mepr-form' ).on('submit',function(){
				wpf_memberpress_checkout();
			});
		} else {
			$( '.mepr-signup-form input[name="user_email"]' ).blur(function(){
				wpf_memberpress_checkout();
			});
		}

		// PMPro
		$( '#pmpro_form input#bemail' ).blur(function() {
			wpf_pmpro_checkout();
		});

		// EDD.
		EDDAbandonedCart();

	}, 3000);


	// MemberPress

	function wpf_memberpress_checkout(){
		// Validate email
		var email = $('input[name="user_email"]').val();

		if( regex.test(email) == true && didSend == false ) {
			var data = {
				'action'     : 'wpf_abandoned_cart_memberpress',
				'first_name' : $('input[name="user_first_name"]').val(),
				'last_name'  : $('input[name="user_last_name"').val(),
				'user_email' : $('input[name="user_email"]').val(),
				'data'       : $('form.mepr-signup-form').serialize(),
				'product_id' : $('input[name="mepr_product_id"]' ).val(),
				'source'     : 'memberpress',
				'nonce'      : wpf_ac_data.nonce,
			}

			$.post(wpf_ac_data.ajaxurl, data);

			didSend = true;
		}
	}


	// PMPro

	function wpf_pmpro_checkout(){
		// Validate email
		var email = $('input#bemail').val();

		if( didSend == false && regex.test( email ) == true) {

			var data = {
				'action'      : 'wpf_abandoned_cart_pmpro',
				'first_name'  : $('input#bfirstname').val(),
				'last_name'   : $('input#blastname').val(),
				'user_email'  : $('input#bemail').val(),
				'pmpro_level' : $('input#pmpro_level').val(),
				'source'      : 'pmpro',
				'nonce'       : wpf_ac_data.nonce,
			}

			$.post( wpf_ac_data.ajaxurl, data );

			didSend = true;

		}
	}


	// Easy Digital Downloads

	function EDDAbandonedCart()  {

		$( '#edd_checkout_user_info input' ).blur(function() {

			// Validate email
			var email = $('input#edd-email').val();
			var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;

			if( didSend == false && regex.test( email ) == true && $('input#edd-first').val() && $('input#edd-last').val() ) {

				didSend = true;

				var data = {
					'action'     : 'wpf_abandoned_cart_edd',
					'first_name' : $('input#edd-first').val(),
					'last_name'  : $('input#edd-last').val(),
					'user_email' : $('input#edd-email').val(),
					'source'     : 'edd',
					'nonce'      : wpf_ac_data.nonce,
				}

				$.post(wpf_ac_data.ajaxurl, data);

			}

		});

	}


	$('body').on('edd_gateway_loaded', function( event, payment_mode ) {

		// Cases with multiple gateways
		EDDAbandonedCart();

	});


});